love.graphics.setMode(1000,1000,false,true)

require "lighting"
require "shadows"
require "scene"

function love.load()
    love.graphics.setBackgroundColor(30,30,30)
    unlightedSceneCanvas = love.graphics.newCanvas()
    lightingShader = love.graphics.newPixelEffect("lighting.pixeleffect")
    
    counter = 0
end

function drawScene()
    for i=1,#scene do
        love.graphics.polygon("fill", unpack(scene[i]))
    end
end

function love.draw()
-- draw unlighted scene in canvase
    love.graphics.setPixelEffect()
    love.graphics.setBlendMode("alpha")
    love.graphics.setStencil()
    love.graphics.setCanvas(unlightedSceneCanvas)
    love.graphics.setColor(love.graphics.getBackgroundColor())
    love.graphics.rectangle("fill",0,0,love.graphics.getWidth(),love.graphics.getHeight())
    love.graphics.setColor(255,255,255,255)
    -- drawScene()
    love.graphics.setCanvas()
    
-- light the scene
    -- draw ambient light
    love.graphics.setColor(unpack(lights.ambient))
    love.graphics.draw(unlightedSceneCanvas)
    
    love.graphics.setColor(255,255,255)
    love.graphics.setPixelEffect(lightingShader)
   
   -- create lightdata for shader
    love.graphics.setBlendMode("additive")
    love.graphics.setStencil(shadowStencil)
    local lightsOnScreen = 0
    for i=1,#lights do
        local curLightX = lights[i].x
        local curLightY = lights[i].y
        local curLightRange = lights[i].range
        local curLightColor = lights[i].color
        
        if  curLightX+curLightRange > 0 and curLightX-curLightRange < love.graphics.getWidth()
        and curLightY+curLightRange > 0 and curLightY-curLightRange < love.graphics.getHeight()
        then
            local lightposrange = {curLightX, love.graphics.getHeight()-curLightY, curLightRange}
            lights.current = lights[i]
            love.graphics.setInvertedStencil(shadowStencil)
            
            lightingShader:send("lightposrange", lightposrange)
            lightingShader:send("lightcolor", curLightColor)
            love.graphics.draw(unlightedSceneCanvas)
            love.graphics.setColor(love.graphics.getBackgroundColor())
            love.graphics.rectangle("fill", curLightX-curLightRange,
                                            curLightY-curLightRange,
                                            curLightRange*2, 
                                            curLightRange*2)
            
            lightsOnScreen = lightsOnScreen + 1
        end
    end
    love.graphics.setPixelEffect()
    love.graphics.setBlendMode("alpha")
    love.graphics.setStencil()
    love.graphics.setColor(unpack(lights.ambient))
    drawScene()
    love.graphics.setColor(255,255,255)
    love.graphics.print("lights on screen: " .. lightsOnScreen,10,10)
    love.graphics.print("polygons on screen: " .. #scene,10,30)
    love.graphics.print("vertices on screen: " .. vertexcount,10,50)
    love.graphics.print("FPS: " .. love.timer.getFPS(),10,70)
end

function love.update(dt)
    lights[1].x, lights[1].y = love.mouse.getPosition()
    counter = counter + dt/4
    local useSin = true
    local mathfunc
    for i=2,#lights do
        if useSin then
            mathfunc = math.sin
        else
            mathfunc = math.cos
        end
        lights[i].y = mathfunc(counter)*love.graphics.getHeight()*i*2/#lights
        useSin = not useSin
    end
end